
/*-------------------------------------------------------------------------*/
/**
  @file	vecutils.h
  @author	R. Flamary
  @date		Sep 2015
  @brief	simple functions for vector handling.

*/
/*--------------------------------------------------------------------------*/



#ifndef _VECTUTILS_H_
#define _VECTUTILS_H_

/*---------------------------------------------------------------------------
                                Includes
 ---------------------------------------------------------------------------*/

#include <math.h>
#include <stdlib.h>

double *vzeros(int n)
{
  double * res= malloc(n*sizeof(double));
  for (int i=0;i<n;i++)
    res[i]=0;
  return res;
}

double *vones(int n)
{
  double * res= malloc(n*sizeof(double));
  for (int i=0;i<n;i++)
    res[i]=1;
    return res;
}

double *linspace(double a, double b, int n)
{
  double * res= malloc(n*sizeof(double));
  double delta=(b-a)/(n-1);
  for (int i=0;i<n;i++)
    res[i]=a+i*delta;
  return res;
}

double *vmap(double (*f)(double),double *x, int n)
{
  double * res= malloc(n*sizeof(double));
  for (int i=0;i<n;i++)
    res[i]=f(x[i]);
  return res;
}

void vmap2(double (*f)(double),double *x, int n, double * res)
{
  for (int i=0;i<n;i++)
    res[i]=f(x[i]);
}


#endif
